
scale_worm_larva = 0.2


--- BASE Worm 
NE_Base_Worm_Larva = table.deepcopy(data.raw.turret["small-worm-turret"])
NE_Base_Worm_Larva.name = "ne-base-larva-worm"
NE_Base_Worm_Larva.max_health = 5
NE_Base_Worm_Larva.alert_when_damaged = false
NE_Base_Worm_Larva.alert_when_attacking = false
NE_Base_Worm_Larva.resistances = {}
NE_Base_Worm_Larva.loot = {}



NE_Base_Worm_Larva.folded_animation = worm_folded_animation(scale_worm_larva, tint_worm_small)
NE_Base_Worm_Larva.preparing_animation = worm_preparing_animation(scale_worm_larva, tint_worm_small, "forward")
NE_Base_Worm_Larva.prepared_animation = worm_prepared_animation(scale_worm_larva, tint_worm_small)
NE_Base_Worm_Larva.prepared_alternative_animation = worm_prepared_alternative_animation(scale_worm_larva, tint_worm_small)
NE_Base_Worm_Larva.starting_attack_animation = worm_start_attack_animation(scale_worm_larva, tint_worm_small)
NE_Base_Worm_Larva.ending_attack_animation = worm_end_attack_animation(scale_worm_larva, tint_worm_small)
NE_Base_Worm_Larva.folding_animation =  worm_preparing_animation(scale_worm_larva, tint_worm_small, "backward")
NE_Base_Worm_Larva.integration = worm_integration(scale_worm_larva)
NE_Base_Worm_Larva.autoplace = nil
NE_Base_Worm_Larva.corpse = "larva-worm-corpse"
NE_Base_Worm_Larva.attack_parameters =
{
  type = "stream",
  cooldown = 4,
  range = range_worm_small,--defined in spitter-projectiles.lua
  damage_modifier = damage_modifier_worm_small,--defined in spitter-projectiles.lua
  min_range = 0,
  projectile_creation_parameters = worm_shoot_shiftings(scale_worm_larva, scale_worm_larva * scale_worm_stream),
  use_shooter_direction = true,

  lead_target_for_projectile_speed = 0.2* 0.75 * 1.5 *1.5, -- this is same as particle horizontal speed of flamethrower fire stream

  ammo_type =
  {
    category = "biological",
    action =
    {
      type = "direct",
      action_delivery =
      {
        type = "stream",
        stream = "acid-stream-worm-small",
        source_offset = {0.15, -0.5}
      }
    }
  },

  cyclic_sound =
  {
    begin_sound =
    {
      {
        filename = "__base__/sound/creatures/worm-spit-start.ogg",
        volume = 0.0
      },
      {
        filename = "__base__/sound/creatures/worm-spit-start-2.ogg",
        volume = 0.0
      },
      {
        filename = "__base__/sound/creatures/worm-spit-start-3.ogg",
        volume = 0.0
      }
    },
    end_sound =
    {
      {
        filename = "__base__/sound/creatures/worm-spit-end.ogg",
        volume = 0.0
      }
    }
  }
}

data:extend{NE_Base_Worm_Larva}


data:extend(
{
    {
        type = "corpse",
        name = "larva-worm-corpse",
        icon = "__base__/graphics/icons/small-worm-corpse.png",
        icon_size = 64, icon_mipmaps = 4,
        selection_box = {{-0.8, -0.8}, {0.8, 0.8}},
        selectable_in_game = false,
        dying_speed = 0.01,
        time_before_removed = 5 * 60 * 60,
        subgroup="corpses",
        order = "c[corpse]-c[worm]-a[small]",
        flags = {"placeable-neutral", "placeable-off-grid", "building-direction-8-way", "not-repairable", "not-on-map"},
        final_render_layer = "lower-object-above-shadow",
        animation = worm_die_animation(scale_worm_larva, tint_worm_small),
        ground_patch =
        {
        sheet = worm_integration(scale_worm_larva)
        }
    },
})


-- Worm Adjustments
if NE_Enemies.Settings.NE_Adjust_Vanilla_Worms then

    ----- Small Worms	
    data.raw["turret"]["small-worm-turret"].max_health = 200 + 100 * NE_Enemies.Settings.NE_Difficulty
    data.raw["turret"]["small-worm-turret"].attack_parameters.range = 24 + NE_Enemies.Settings.NE_Difficulty
    data.raw["turret"]["small-worm-turret"].resistances = Resistances.Small_Worm

    ----- Medium Worms
    data.raw["turret"]["medium-worm-turret"].attack_parameters = Worm_Attack_Stream({
        range = 29 + NE_Enemies.Settings.NE_Difficulty,
        cooldown = 8 - NE_Enemies.Settings.NE_Difficulty,
        damage_modifier = 4,
        ammo_type = data.raw["turret"]["medium-worm-turret"].attack_parameters.ammo_type
    })
    data.raw["turret"]["medium-worm-turret"].max_health = 200 + 200 * NE_Enemies.Settings.NE_Difficulty
    data.raw["turret"]["medium-worm-turret"].resistances = Resistances.Medium_Worm
    data.raw["turret"]["medium-worm-turret"].call_for_help_radius = 100 + (NE_Enemies.Settings.NE_Difficulty * 2)
    data.raw["turret"]["medium-worm-turret"].attack_parameters.ammo_category = "ne-flame"
    data.raw["turret"]["medium-worm-turret"].attack_parameters.ammo_type.category = "ne-flame"

    ----- Big Worms	(Give Big Worm the Unit Launch Ability)
    data.raw["turret"]["big-worm-turret"].attack_parameters = Worm_Attack_Projectile_NH({
        range = 35 + NE_Enemies.Settings.NE_Difficulty,
        cooldown = 46 - NE_Enemies.Settings.NE_Difficulty,
        damage_modifier = 5,
        projectile = "Worm-Unit-Projectile"
    })
    data.raw["turret"]["big-worm-turret"].max_health = 500 + 200 * NE_Enemies.Settings.NE_Difficulty
    data.raw["turret"]["big-worm-turret"].resistances = Resistances.Big_Worm
    data.raw["turret"]["big-worm-turret"].call_for_help_radius = 150 + (NE_Enemies.Settings.NE_Difficulty * 2)
    data.raw["turret"]["big-worm-turret"].attack_parameters.ammo_category = "ne-projectile"
    data.raw["turret"]["big-worm-turret"].attack_parameters.ammo_type.category = "ne-projectile"

    ----- Behemoth Worms	
    data.raw["turret"]["behemoth-worm-turret"].attack_parameters.range = 47 + NE_Enemies.Settings.NE_Difficulty
    data.raw["turret"]["behemoth-worm-turret"].attack_parameters.cooldown = 10 - NE_Enemies.Settings.NE_Difficulty
    data.raw["turret"]["behemoth-worm-turret"].max_health = 700 + 200 * NE_Enemies.Settings.NE_Difficulty
    data.raw["turret"]["behemoth-worm-turret"].resistances = Resistances.Behemoth_Worm
    data.raw["turret"]["behemoth-worm-turret"].call_for_help_radius = 180 + (NE_Enemies.Settings.NE_Difficulty * 2)

    --[[ -- Was thinking to update the players worm turrets from NE Buildings....
	if data.raw["turret"]["medium-worm-turret-player"] then
	data.raw["turret"]["medium-worm-turret-player"].attack_parameters = Worm_Attack_Stream(
						{
							range = 29 + NE_Enemies.Settings.NE_Difficulty,
							cooldown = 8 - NE_Enemies.Settings.NE_Difficulty,
							damage_modifier = 4,
						})
	end

	if data.raw["turret"]["behemoth-worm-turret-player"] then
	data.raw["turret"]["behemoth-worm-turret-player"].attack_parameters = Worm_Attack_Projectile_NH(
						{
							range = 40 + NE_Enemies.Settings.NE_Difficulty,
							cooldown = 46 - NE_Enemies.Settings.NE_Difficulty,
							damage_modifier = 5,
							projectile="Worm-Unit-Projectile"
						})
	end
	]]
end
